std::reference_wrapper< _Tp >(3cxx)

NAME
std::reference_wrapper< _Tp > - Primary class template for reference_wrapper.

SYNOPSIS

#include <refwrap.h>

  Public Types

typedef _Tp type

  Public Member Functions

template<typename _Up, typename = __not_same<_Up>, typename = decltype(reference_wrapper::_S_fun(std::declval<_Up>()))> constexpr reference_wrapper (_Up &&__uref) noexcept(noexcept(reference_wrapper::_S_fun(std::declval< _Up >())))
reference_wrapper (const reference_wrapper &)=default
constexpr _Tp & get () const noexcept
constexpr operator _Tp & () const noexcept
template<typename... _Args> constexpr __invoke_result< _Tp &, _Args... >::type operator() (_Args &&... __args) const noexcept(__is_nothrow_invocable< _Tp &, _Args... >::value)
reference_wrapper & operator= (const reference_wrapper &)=default

  Related Symbols
(Note that these are not member symbols.)

template<typename _Tp> constexpr reference_wrapper< _Tp > ref (_Tp &__t) noexcept
Denotes a reference should be taken to a variable.
template<typename _Tp> constexpr reference_wrapper< const _Tp > cref (const _Tp &__t) noexcept
Denotes a const reference should be taken to a variable.
template<typename _Tp> constexpr reference_wrapper< _Tp > ref (reference_wrapper< _Tp > __t) noexcept
std::ref overload to prevent wrapping a reference_wrapper
template<typename _Tp> constexpr reference_wrapper< const _Tp > cref (reference_wrapper< _Tp > __t) noexcept
std::cref overload to prevent wrapping a reference_wrapper

Detailed Description

  template<typename _Tp>
class std::reference_wrapper< _Tp >"Primary class template for reference_wrapper.

Friends And Related Symbol Documentation

  template<typename _Tp> reference_wrapper< const _Tp > cref (const _Tp & __t) [related]

Denotes a const reference should be taken to a variable.

  template<typename _Tp> reference_wrapper< const _Tp > cref (reference_wrapper< _Tp > __t) [related]

std::cref overload to prevent wrapping a reference_wrapper

  template<typename _Tp> reference_wrapper< _Tp > ref (_Tp & __t) [related]

Denotes a reference should be taken to a variable.

  template<typename _Tp> reference_wrapper< _Tp > ref (reference_wrapper< _Tp > __t) [related]

std::ref overload to prevent wrapping a reference_wrapper

Author

Generated automatically by Doxygen for libstdc++ from the source code.